unit FunAbsolutelyNothing;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TFunAbsolutelyNothing = class(TComponent)
  private
    FName: TComponentName;
    sc: Integer;
    procedure ReadSc(Reader: TReader);
    procedure WriteSc(Writer: TWriter); // secret code
  protected
    procedure SetName(const NewName: TComponentName); override;
  public
    property Name: TComponentName read FName write SetName;
    procedure DefineProperties (Filer: TFiler); override;
    procedure Loaded; override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('FunSide', [TFunAbsolutelyNothing]);
end;

{ TFunAbsolutelyNothing }

procedure TFunAbsolutelyNothing.DefineProperties(Filer: TFiler);
begin
  inherited;
  Filer.DefineProperty('SecretCode',
    ReadSc, WriteSc, sc <> 0);
end;

procedure TFunAbsolutelyNothing.ReadSc(Reader: TReader);
begin
  sc := Reader.ReadInteger;
end;

procedure TFunAbsolutelyNothing.WriteSc(Writer: TWriter);
begin
  Writer.WriteInteger(sc);
end;

procedure TFunAbsolutelyNothing.SetName(const NewName: TComponentName);
begin
  FName := NewName;
end;

procedure TFunAbsolutelyNothing.Loaded;
begin
  inherited;
  if sc = 0 then
    sc := GetTickCount;
end;

end.
